#include <stdint.h>

#include "main.h"
#include "ipc.h"

void parent_workflow( dist_info_t *info ) {
  Message msg;
  uint8_t receive_cnt;

  my_info_t me = {
    .id = PARENT_ID,
    .dist_info = info
  };

  // PARENT PHASE 0: Close all redundant descriptors
  close_redundant_pipes( info, PARENT_ID );

  // PARENT PHASE 1: Receive all STARTED messages
  receive_cnt = info->x;
  while( receive_cnt ) {
    Message msg;
    if( receive_any( &me, &msg ) ) {
      if( msg.s_header.s_type != STARTED )
        return;

      receive_cnt--;
    }
  }

  // PARENT PHASE 2: Receive all DONE messages
  receive_cnt = info->x;
  while( receive_cnt ) {
    Message msg;
    if( receive_any( &me, &msg ) ) {
      if( msg.s_header.s_type != DONE )
        return;

      receive_cnt--;
    }
  }

  // PARENT PHASE 3: Wait for the end of all processes
}
